(function($){
    var PlgSysExternalLinkWarning = Class.create({
        hostname:null,
        options: {
            sitename:false,
            warningexcludeclasses:'{"classes":[]}',
            uselinkicon:false,
            linkicon:'',
            linkiconexcludeclasses:'{"classes":[]}'
        },
        init:function(options) {
            var self = this;
            var parse = ['warningexcludeclasses','linkiconexcludeclasses'];
            $.each(options,function(index,value){ 
                self.options[index]=(parse.indexOf(index)==-1)?value:JSON.parse(value); 
            });
            self.hostname = self.getHostname(window.location.href);
            var links = self.findLinks();
            if(options.uselinkicon) self.markLinks(links);
        },
        getHostname:function(url){
            var s = document.createElement("a");
            s.href = url;
            return s.hostname;
        },
        findLinks:function() {
            var self = this;
            var links = [];
            $.each($('a'),function(i,el){
                if(el.href.substring(0,4) !== 'http') return true;
                if(el.hostname !== self.hostname) {
                    var classes = el.className.split(/\s+/);
                    if(self.arrayIntersect(self.options.warningexcludeclasses,classes) >= 1) return true;
                    links.push(el);
                    $(el).click(function(e){
                        e.stopPropagation();
                        e.preventDefault();
                        self.linkWarning(el.href);
                    });
                }
            });
            return links;
        },
        arrayIntersect:function(a1,a2){
            return $.map(a1,function(a){return $.inArray(a, a2) < 0 ? null : a;});
        },
        linkWarning:function(url){
            var self = this;
            var desthost = self.getHostname(url);
            if(confirm(Joomla.JText._('PLG_SYS_EXTERNALLINKWARNING_WARNINGTEXT').replace('{domain}',self.hostname).replace('{destdomain}',desthost).replace('{sitename}',self.options.sitename))) {
                window.open(url,'_blank');
            }
        },
        markLinks:function(links) {
            var self = this;
            $.each(links,function(i,el){
                if(self.arrayIntersect(self.options.linkiconexcludeclasses,el.className.split(/\s+/)) >= 1) return true;
                $.each(self.options.linkicon.split(' '),function(i,c){
                    $(el).addClass(c);
                });
            });
        }
    });
    $(document).ready(function(){
        window.plg_system_externallinkwarning = new PlgSysExternalLinkWarning(window.plg_system_externallinkwarning_options);
    });
})(jQuery);